<?php
// $Id: mail_ru_auth.admin.inc,v 1.1 2010/08/03 12:27:26 seaji Exp $

/**
  * @file
  * Settings of mail_ru_auth
  */

function mail_ru_auth_admin_settings() {
  global $base_url;

  $form['global'] = array(
    '#type' => 'fieldset',
    '#title' => t('Mail.ru Auth settings'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['global']['register_site'] = array(
    '#type' => 'markup',
    '#value' => '<div class="register_site">'. t('Register your site here: !reg_url first.', array('!reg_url' => l('api.mail.ru/sites/my/add', 'http://api.mail.ru/sites/my/add/'))) .'</div>',
  );

  $form['global']['mail_ru_auth_app_id'] = array(
    '#type' => 'textfield',
    '#title' => t('Application ID'),
    '#description' => t('Enter your Application ID'),
    '#default_value' => variable_get('mail_ru_auth_app_id', ''),
  );

  $form['global']['mail_ru_auth_private_key'] = array(
    '#type' => 'textfield',
    '#title' => t('Private key'),
    '#description' => t('Enter your private key'),
    '#default_value' => variable_get('mail_ru_auth_private_key', ''),
  );

  $form['global']['mail_ru_auth_secret_key'] = array(
    '#type' => 'textfield',
    '#title' => t('Secret key'),
    '#description' => t('Enter your secret key'),
    '#default_value' => variable_get('mail_ru_auth_secret_key', ''),
  );

  $form['global']['mail_ru_auth_url'] = array(
    '#type' => 'textfield',
    '#title' => t('Site URL'),
    '#default_value' => variable_get('mail_ru_auth_url', $base_url . base_path()),
  );

  $form['global']['mail_ru_auth_base_url'] = array(
    '#type' => 'textfield',
    '#title' => t('Base URL'),
    '#default_value' => variable_get('mail_ru_auth_base_url', base_path()),
  );

  $form['global']['mail_ru_auth_redirect_url'] = array(
    '#type' => 'textfield',
    '#title' => t('Redirect URL'),
    '#default_value' => variable_get('mail_ru_auth_redirect_url', ""),
  );

  $form['global']['mail_ru_auth_alter_login_form'] = array(
    '#type' => 'select',
    '#title' => t('Show Mail.ru button on login form'),
    '#default_value' => variable_get('mail_ru_auth_alter_login_form', 1),
    '#options' => array(
      '0' => t('Do not add Mail.ru button to login form'),
      '1' => t('Add Mail.ru button to login form'),
    ),
  );

  $form['new_user'] = array(
    '#type' => 'fieldset',
    '#title' => t('New user settings'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );
  $form['new_user']['mail_ru_auth_username'] = array(
    '#type' => 'select',
    '#title' => t('Default user name.'),
    '#description' => t('Select "Nick" or "Login". "Nick" - is last and first name. "Login" - is login at mail.ru'),
    '#options' => array(
      MAILRU_DEFAULT_LOGIN => t('Login'),
      MAILRU_DEFAULT_NICK => t('Nick'),
    ),
    '#default_value' => variable_get('mail_ru_auth_username', MAILRU_DEFAULT_LOGIN),
  );

  $disabled = TRUE;
  if(variable_get('user_pictures', 0)) {
    $disabled = FALSE;
  }
  $form['new_user']['mail_ru_auth_avatar'] = array(
    '#type' => 'select',
    '#title' => t('Use mail.ru avatar'),
    '#default_value' => variable_get('mail_ru_auth_avatar', 0),
    '#options' => array(
      '0' => t('Don\'t use'),
      '1' => t('Use small avatar 45x45'),
      '2' => t('Use medium avatar 90x90'),
      '3' => t('Use big avatar'),
    ),
    '#disabled' => $disabled,
    '#description' => t('You should enable pictures support on <a href="@usp">user settings page</a>.', array('@usp' => base_path() . 'admin/user/settings')),
  );

  $q = db_query("SELECT * FROM {role} WHERE rid > 2");
  while($r = db_fetch_object($q)) {
    $roles[$r->rid] = $r->name;
  }
  $form['new_user']['mail_ru_auth_role_for_new_user'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Role for new mail.ru user'),
    '#default_value' => variable_get('mail_ru_auth_role_for_new_user', array('0' => t('None'))),
    '#options' => $roles,
  );

  if(variable_get('mail_ru_auth_avatar', 0) && !function_exists('curl_init')) {
    variable_set('mail_ru_auth_avatar', 0);
    drupal_set_message(t('You can\'t use mail.ru avatars because  your PHP don\'t support <a href="http://ru2.php.net/curl">CURL functions</a>.'), 'error');
    drupal_goto('admin/settings/mail_ru_auth');
  }

  $form = system_settings_form($form);
  return $form;
}